#include <iostream>
#include <cassert>

unsigned my_sqrt(unsigned input)
{
    unsigned top = input;
    unsigned bot = 0;
    unsigned mid;

    for (int i = 0; i < 10; i++)
    {
        mid = (top + bot) / 2;
        unsigned mid2 = mid * mid;
        if (mid2 < input)
        { bot = mid; }
        else if (mid2 > input)
        { top = mid; }
    }

    mid = (top + bot) / 2;
    unsigned mip = mid + 1;

    assert((mid * mid <= input) &&
           (mip * mip >= input));

    return mid;
}

int main(int argc, char* argv[])
{
    if (argc != 2)
    {
        std::cout << "Please provide a number" << std::endl;
        return 1;
    }

    unsigned input;
    try { input = std::stoul(argv[1]); }
    catch (std::invalid_argument& e)
    {
        std::cout << "Invalid input" << std::endl;
        return 2;
    }
    unsigned sqrt = my_sqrt(input);
    std::cout << "Input: " << input << " Sqrt: " << sqrt << std::endl;

    return 0;
}


